#include <qmainwindow.h>
#include <qwidget.h>
#include <qtabwidget.h>
#include <qpopupmenu.h>
#include <qpe/qpemenubar.h>
#include <qlist.h>

class QGridLayout; 
class QBoxLayout;
class QLabel;
class QListView;
class QCheckListItem;
class QListViewItem;
class QPushButton;
class QTabWidget;
class AppLnkSet;

struct MenuSet {
	QString type;
	QWidget* wid;
	QBoxLayout* lay;
	QListView* list;
};

class PreloadMgr : public QMainWindow
{
	Q_OBJECT

public:
	PreloadMgr() ;
	~PreloadMgr() ;

private slots:
	void setDocument(const QString& s);
	void stopClicked();
	void startClicked();
	void ststClicked();
//	void listSelected(QListViewItem* );
	void refreshInfo();
	void systemMessage(const QCString&, const QByteArray&);

private:
	void loadCfg();
	void loadDesktop();
	void loadMenuTab();
	void stopApps(const QString& name);
	void startApps(const QString& name);
	void makeMenuTab(const QIconSet& ic,const QString& s ,const QString& t);
	MenuSet* findTab(QString s);

	AppLnkSet *set;
	QTimer *timer;
	QTabWidget* tabWidget;

	QWidget* mainTab;
	QGridLayout* mainTabLayout;
	QListView* appsList;
	QLabel* memLabel;
	QPushButton* stopButton;
	QPushButton* startButton;
	QPushButton* ststButton;
	enum {
		listRow,
		buttonRow,
	};
	enum {
		stopButtonCol,
		startButtonCol,
		ststButtonCol,
		upButtonCol,
		downButtonCol
	};
	enum {
		Status,
		AppsName,
		RealName
	};

	QTabWidget* setTab;
	QList<MenuSet> menuSet;
	enum {
		AllAvail,
		AllAppsName,
		AllRealName
	};
	
};
